/****************************************************************************/
/**    GNOM - Gnom Is NOt MCuT                                             **/
/**  Copyright (C) 1997 Jochen Sarrazin, DG6VJ. All righs reserved.        **/
/**                                                                        **/
/**  Display-Routinen...                                                   **/
/****************************************************************************/

#include "global.h"
#include "display.h"

#include <string.h>
#include "toolbox.h"
#include "utils.h"

char TNC_Status[15][4] = {"DIS","SET","FMR","DRQ","IXF","REJ","WAK","DBS","RBS","BBS","WDB","WRB",
                          "RDB","RRB","RBB"};


void debugchar(char ch)
{
  int fd;
  
  fd = open("debug.file",O_WRONLY|O_APPEND);
  
  write(fd,&ch,1);
  close(fd);
}



/* Bildschirm initialisieren */
void display_init()
{
  int use_colors=FALSE;
  
  /* Curses initialisieren */
  initscr();
  if (has_colors) use_colors = TRUE;
  cbreak();
  noecho();
  nonl();
  
  /* Anzahl der Zeilen+Spalten */
  size_col = COLS;
  size_lines = LINES;
  
  /* Gre des RX- und TX- Fensters (in Zeilen) berechnen */
  size_rx = rx_lower-rx_upper+1;
  size_tx = tx_lower-tx_upper+1;
  
  /* Fenster erzeugen */
  tx_win = newwin(size_tx,size_col,tx_upper,0);
  rx_win = newwin(size_rx,size_col,rx_upper,0);
  stoben_win = newwin(1,size_col,0,0);
  stunten_win = newwin(1,size_col,pos_statusline,0);
  keypad(tx_win,TRUE);
  
  scrollok(tx_win,TRUE);
  scrollok(rx_win,TRUE);
  
  if (use_colors)
  {
    start_color();
    
    /* Farben der Fenster setzen */
    init_pair(1, (colors[0]&7), (colors[1]&7));	/* Status-Zeile */
    init_pair(17, (colors[0]&7), (colors[8]&7));	/* Status-Zeile fr Fortschrittsanzeige AutoBIN/7plus-Transfer */
    init_pair(2, (colors[2]&7), (colors[3]&7));	/* RX-Fenster (gesendete Frames) */
    init_pair(3, (colors[4]&7), (colors[5]&7));	/* TX-Fenster */
    init_pair(10, (colors[7]&7), (colors[3]&7));	/* RX-Fenster (empfangene Frames) */
    init_pair(11, (colors[6]&7), (colors[3]&7));	/* RX-Fenster (Status-Texte) */
     
    /* Farben fr die Monitor-Geschichte */
    init_pair(12, (colors[10]&7), (colors[9]&7));	/* Monitor: Portname */
    init_pair(13, (colors[11]&7), (colors[9]&7));	/* Monitor: Protokoll (AX25/EAX25) */
    init_pair(14, (colors[12]&7), (colors[9]&7));	/* Monitor: Rufzeichen */
    init_pair(15, (colors[14]&7), (colors[9]&7));	/* Monitor: Daten */
    init_pair(16, (colors[13]&7), (colors[9]&7));	/* Monitor: Der ganze Rest des Headers */
    attribs[0] = COLOR_PAIR(1);
    attribs[1] = COLOR_PAIR(2);			/* RX-Fenster (gesendete Frames) */
    attribs[2] = COLOR_PAIR(3);
    attribs[3] = COLOR_PAIR(10);			/* RX-Fenster (empfangene Frames) */
    attribs[4] = COLOR_PAIR(11);			/* RX-Fenster (Status-Texte) */
    attribs[5] = COLOR_PAIR(12);			/* Monitor: Portname */
    attribs[6] = COLOR_PAIR(13);			/* Monitor: Protokoll (AX25/EAX25) */
    attribs[7] = COLOR_PAIR(14);			/* Monitor: Rufzeichen */
    attribs[8] = COLOR_PAIR(15);			/* Monitor: Daten */
    attribs[9] = COLOR_PAIR(16);			/* Monitor: Der Rest des Headers */
    attribs[10] = COLOR_PAIR(17);			

    if (colors[0]>7) attribs[0] |= A_BOLD;
    if (colors[0]>7) attribs[10] |= A_BOLD;
    if (colors[2]>7) attribs[1] |= A_BOLD;
    if (colors[4]>7) attribs[2] |= A_BOLD;
    if (colors[7]>7) attribs[3] |= A_BOLD;
    if (colors[6]>7) attribs[4] |= A_BOLD;
    if (colors[10]>7) attribs[5] |= A_BOLD;
    if (colors[11]>7) attribs[6] |= A_BOLD;
    if (colors[12]>7) attribs[7] |= A_BOLD;
    if (colors[14]>7) attribs[8] |= A_BOLD;
    if (colors[13]>7) attribs[9] |= A_BOLD;
  }

#ifdef SLANG
  wattron(rx_win,attribs[1]);
  wattron(tx_win,attribs[2]);
  wattron(stoben_win,attribs[0]);
  wattron(stunten_win,attribs[0]);
#else
  /* Hintergrundfarbe */
  wbkgdset(rx_win,attribs[1]);
  wbkgdset(tx_win,attribs[2]);
  wbkgdset(stoben_win,attribs[0]);
  wbkgdset(stunten_win,attribs[0]);
#endif

  wclear(tx_win);
  wclear(rx_win);
  wclear(stoben_win);
  wclear(stunten_win);

  x_akt = 0;
  y_akt = 0;

  /* Den Bildschirm neu aufbauen */
  display_newscreen();
}



/* Deinitialisiere den Bildschirm */
void display_deinit()
{

  /* Fenster lschen */
  delwin(tx_win);
  delwin(rx_win);

  echo();
  endwin();

}



void update_upper_statusline(int redraw)
{
  char flagstring[25]="";
  char name[21],call[10];
  
  if (chaninfo[AktChan]->name == NULL)
     name[0] = '\0';
  else
     strcpy(name,chaninfo[AktChan]->name);
  
  if (chaninfo[AktChan]->call[0] == '\0')
     strcpy(call,"--------");
  else
     strcpy(call,chaninfo[AktChan]->call);
  
  sprintf(flagstring,"%sR%i/T%i ",flagstring,chaninfo[AktChan]->convert_rx,chaninfo[AktChan]->convert_tx);
  
  if ((chaninfo[AktChan]->flags & CH_COMP) == CH_COMP)
     strcat(flagstring,"C");
  else
     strcat(flagstring,"-");
  
  if (chaninfo[AktChan]->pwinfo != NULL)
     if (chaninfo[AktChan]->pwinfo->pwmode != 0)
        strcat(flagstring,"p");
     else
        strcat(flagstring,"-");
  else
     strcat(flagstring,"-");
  
  if ((chaninfo[AktChan]->flags & CH_SAVE) == CH_SAVE)
     strcat(flagstring,"S");
  else
     strcat(flagstring,"-");
  
  if ((chaninfo[AktChan]->flags & CH_7PLUS) == CH_7PLUS)
     strcat(flagstring,"7");
  else if ((chaninfo[AktChan]->flags & CH_CHECK7PLUS) == 0)
          strcat(flagstring,"_");
       else
          strcat(flagstring,"-");
  
  if (((chaninfo[AktChan]->flags & CH_AUTOBINRX) == CH_AUTOBINRX) ||
      ((chaninfo[AktChan]->flags & CH_AUTOBINTX) == CH_AUTOBINTX))
     strcat(flagstring,"A");
  else if ((chaninfo[AktChan]->flags & CH_CHECKAUTOBIN) == CH_CHECKAUTOBIN)
          strcat(flagstring,"a");
       else
          strcat(flagstring,"-");
  
  if ((chaninfo[AktChan]->flags & CH_REMOTE) == CH_REMOTE)
     strcat(flagstring,"R");
  else
     strcat(flagstring,"-");
  
  if ((chaninfo[AktChan]->flags & CH_PROMPT) == CH_PROMPT)
     strcat(flagstring,"P");
  else
     strcat(flagstring,"-");
  
  if (insert)
     strcat(flagstring,"I");
  else
     strcat(flagstring,"O");
  
  
  mvwprintw(stoben_win,0,0," %3i  %9s   %20s   %3s  |%.2i|%.2i|%.2i| %22s",
                           AktChan,call,name,TNC_Status[chaninfo[AktChan]->status],
                           chaninfo[AktChan]->unack,chaninfo[AktChan]->squeue,chaninfo[AktChan]->tries,
                           flagstring);
  
  if (redraw) {
    /* Cursor im tx-Fenster positionieren */
    wmove(tx_win,y_akt,x_akt-x_screen);
    redrawwin(stoben_win);
    wredrawln(tx_win,0,1);
  }
}



void update_lower_statusline(int redraw)
{
  int i,max,send_sep=FALSE,k,aktpos_attrib=0;
  char tmp2[50],tmp[100]="";
  chtype attrib[100];
  time_t akttime;
  struct tm *thetime;
  
  i = AktChan - 1;
  i = (i / 10) * 10;
  i++;
  
  max = i+9;
  if (max > chancount) max = chancount;
  
  while (i <= max)
  {
    if (send_sep)
    {
      strcat(tmp,"|");
      chtype_write_attribs(attrib,aktpos_attrib,1,0);
      aktpos_attrib += 1;
    }
    else send_sep = TRUE;
    
    if (chaninfo[i]->driverfd == -1)
       if (i == AktChan)
          strcpy(tmp2,"======");
       else
          strcpy(tmp2,"------");
    else {
      CutSSID(tmp2,chaninfo[i]->call);
      if (i == AktChan) Klein(tmp2);
      sprintf(tmp2,"%-6s",tmp2);
    }
    if ((chaninfo[i]->flags & CH_NEWDATA) == 0)
    {
      strcat(tmp,tmp2);
      chtype_write_attribs(attrib,aktpos_attrib,strlen(tmp2),0);
    }
    else
    {
      strcat(tmp,tmp2);
      chtype_write_attribs(attrib,aktpos_attrib,strlen(tmp2),A_BLINK);
    }
    aktpos_attrib += strlen(tmp2);
    
    i++;
  }
  
  /* Beim AutoBIN-RX rechts neben die Rufzeichen die Byte-Anzahl ausgeben, die schon empfangen wurden */
  if (((chaninfo[AktChan]->flags & CH_AUTOBINRX) == CH_AUTOBINRX) ||
      ((chaninfo[AktChan]->flags & CH_AUTOBINTX) == CH_AUTOBINTX))
     sprintf(tmp2,"%10i",chaninfo[AktChan]->autobin->bytes_got);
  else if ((chaninfo[AktChan]->flags & CH_7PLUS) == CH_7PLUS)
          sprintf(tmp2,"%10i",chaninfo[AktChan]->auto7plus->bytes_got);
       else if (config->clock)
            {
              akttime = time(NULL);
              thetime = gmtime(&akttime);
              sprintf(tmp2,"  %.2i:%.2i:%.2i",thetime->tm_hour,thetime->tm_min,thetime->tm_sec);
            }
            else sprintf(tmp2,"%10s","");
  
  strcat(tmp,tmp2);
  chtype_write_attribs(attrib,aktpos_attrib,strlen(tmp2),0);
  aktpos_attrib += strlen(tmp2);
  
  
  /* Sooo... Wenn jetzt eine AutoBIN- oder 7plus-bertragung stattfindet, wird der bertragungs-
   * fortschritt als Farbnderung in dieser Statuszeile angezeigt.
   */
  if (((chaninfo[AktChan]->flags & CH_AUTOBINRX) == CH_AUTOBINRX) ||
      ((chaninfo[AktChan]->flags & CH_AUTOBINTX) == CH_AUTOBINTX) ||
      ((chaninfo[AktChan]->flags & CH_7PLUS) == CH_7PLUS))
  {
    /* Errechnen, wieviele der Bytes mit der neuen Farbe gemalt werden sollen */
    if ((chaninfo[AktChan]->flags & CH_7PLUS) == 0)
       k = (100 * chaninfo[AktChan]->autobin->bytes_got) / chaninfo[AktChan]->autobin->len;
    else
       k = (100 * chaninfo[AktChan]->auto7plus->bytes_got) / chaninfo[AktChan]->auto7plus->len;
    /* Jetzt steht in k der % - Wert - zwischen 0 und 100. */
    k = k * size_col / 100;
  }
  else k = 0;
  
  wmove(stunten_win,0,0);
  i = 0;
  while (i < aktpos_attrib)
  {
    if (i < k)
       waddch(stunten_win,(chtype)tmp[i] | attrib[i] | attribs[ATTR_STATUSLN_TRANS]);
    else
       waddch(stunten_win,(chtype)tmp[i] | attrib[i] | attribs[ATTR_STATUSLN]);
    i++;
  }
  while (i < size_col)
  {
    if (i < k)
       waddch(stunten_win,(chtype)' ' | attribs[ATTR_STATUSLN_TRANS]);
    else
       waddch(stunten_win,(chtype)' ' | attribs[ATTR_STATUSLN]);
    i++;
  }

  if (redraw) {
    /* Cursor im tx-Fenster positionieren */
    wmove(tx_win,y_akt,x_akt-x_screen);
    redrawwin(stunten_win);
    wredrawln(tx_win,0,1);
  }
}



/* Malt den Bildschirm neu: */
void display_newscreen()
{
  int i,k;
  uchar lastcolor;
  s_vorschreib *tmp;
  s_scroll *stmp;


  /* Die beiden Status-Zeilen neu malen - nur im Speicher, nicht auf den Schirm */
  update_upper_statusline(FALSE);
  update_lower_statusline(FALSE);

  /* Vorschreib-Fenster neu malen */
  i = 0;
  tmp = chaninfo[AktChan]->vor_screen;
  while (i < size_tx)
  {
    mvwaddstr(tx_win,i,0,tmp->text);
    wclrtoeol(tx_win);
    tmp = tmp->next;
    i++;
  }


  /* RX-Fenster */
  i = 0;
  stmp = chaninfo[AktChan]->scroll_screen;
  lastcolor = colors[2] + colors[3]*16;		/* Standard-Farbe: RX-Fenster-Farben */
  while (i < size_rx)
  {
    wmove(rx_win,i,0);
    if (stmp->text != NULL)
    {
      k = 0;
      while (k < stmp->blen)
      {
        if (chaninfo[AktChan]->convert_rx == 1)
           waddch(rx_win,((uchar)stmp->text[k] | A_ALTCHARSET | attribs[(uchar)stmp->attrib[k]])); /* ASCII */
        else
           waddch(rx_win,((uchar)stmp->text[k] | attribs[(uchar)stmp->attrib[k]]));  /* was anderes */
        k++;
      }
    }
    wclrtoeol(rx_win);
    stmp = stmp->next;
    i++;
  }
  
  
  /* Cursor im tx-Fenster positionieren */
  wmove(tx_win,y_akt,x_akt-x_screen);

  #ifdef slang
  refresh();
  #else
  redrawwin(stoben_win);
  redrawwin(stunten_win);
  redrawwin(rx_win);
  redrawwin(tx_win);
  #endif
}



/*
 * display_addline schreibt den bergebenen String in den Scrollback-Puffer.
 *
 */
void display_addline(char *str, int length, int chan, char attrib, int paint)
{
  char *tmp;
/*  int *attr;*/
  char *attr;
  int malen=FALSE;		/* den Bildschirm neu malen? */
  int i=0;
  
  tmp = (char *)malloc(chaninfo[chan]->scroll_act->blen + length);
  attr = (char *)malloc(chaninfo[chan]->scroll_act->blen + length);
  
  if (chaninfo[chan]->scroll_act->text != NULL)
  {
    /* Alten Text nach tmp speichern */
    memcpy(tmp,chaninfo[chan]->scroll_act->text,chaninfo[chan]->scroll_act->blen);
    free(chaninfo[chan]->scroll_act->text);
    /* Die Attribute auch */
    memcpy(attr,chaninfo[chan]->scroll_act->attrib,chaninfo[chan]->scroll_act->blen);
    free(chaninfo[chan]->scroll_act->attrib);
  }
  
  
  while (i < length)
  {
    if (str[i] != '\xD')
    {
      tmp[chaninfo[chan]->scroll_act->blen] = str[i];
      attr[chaninfo[chan]->scroll_act->blen] = attrib;
      i++;
      chaninfo[chan]->scroll_act->blen++;
    }
    
    if (i < length)
    if ((chaninfo[chan]->scroll_act->blen == size_col) || (str[i] == 0xD))
    {
      /* Zeichen, die lieber nicht angezeigt werden sollen, werden hier richtig gewandelt. */
      checkshowchars(tmp,chaninfo[chan]->scroll_act->blen);
    
      if (str[i] == 0xD) i++;
    
      /* Fertig - in die Liste eintragen */
      chaninfo[chan]->scroll_act->text = (char *)malloc(chaninfo[chan]->scroll_act->blen+1);
      memcpy(chaninfo[chan]->scroll_act->text,tmp,chaninfo[chan]->scroll_act->blen);
      chaninfo[chan]->scroll_act->text[chaninfo[chan]->scroll_act->blen] = '\0';
      /* Jetzt die Farb-Attribute */
      chaninfo[chan]->scroll_act->attrib = (char *)malloc(chaninfo[chan]->scroll_act->blen);
      memcpy(chaninfo[chan]->scroll_act->attrib,attr,chaninfo[chan]->scroll_act->blen);
    
      /* Wir sind unten am Bildschirm angelangt -> scrollen */
      if (chaninfo[chan]->scroll_act == chaninfo[chan]->scroll_lower)
      {
        if ((chaninfo[chan]->scroll_screen == chaninfo[chan]->scroll_screen_upper) ||
            (chaninfo[chan]->scroll_screen == chaninfo[chan]->scroll_upper))
        {
          chaninfo[chan]->scroll_screen = chaninfo[chan]->scroll_screen->next;
        }
        chaninfo[chan]->scroll_lower = chaninfo[chan]->scroll_lower->next;
        chaninfo[chan]->scroll_screen_upper = chaninfo[chan]->scroll_screen_upper->next;
        chaninfo[chan]->scroll_upper = chaninfo[chan]->scroll_upper->next;
      }
      
      /* Aktuelle Zeile eins weiter */
      chaninfo[chan]->scroll_act = chaninfo[chan]->scroll_act->next;
      if (chaninfo[chan]->scroll_act->blen > 0)
      {
        free(chaninfo[chan]->scroll_act->text);
        free(chaninfo[chan]->scroll_act->attrib);
        chaninfo[chan]->scroll_act->text = NULL;
        chaninfo[chan]->scroll_act->attrib = NULL;
        chaninfo[chan]->scroll_act->blen = 0;
      }
      
      /* Gucken, ob in der aktuellen Zeile was drin steht */
      if (chaninfo[chan]->scroll_act->blen == 0)
      {
        /* nein */
        tmp[0] = '\0';
      }
      else {
        /* ja - Alten Text nach tmp speichern */
        strcpy(tmp,chaninfo[chan]->scroll_act->text);
        memcpy(attr,chaninfo[chan]->scroll_act->attrib,chaninfo[chan]->scroll_act->blen);
        free(chaninfo[chan]->scroll_act->text);
        free(chaninfo[chan]->scroll_act->attrib);
      }
    }
    malen = TRUE;
  }
  
  /* Wenn noch was ber ist, den String in die aktuelle Zeile ausgeben */
  if (tmp[0] != '\0')
  {
    chaninfo[chan]->scroll_act->text = (char *)malloc(chaninfo[chan]->scroll_act->blen+1);
    memcpy(chaninfo[chan]->scroll_act->text,tmp,chaninfo[chan]->scroll_act->blen);
    chaninfo[chan]->scroll_act->text[chaninfo[chan]->scroll_act->blen] = '\0';
    /* Jetzt die Farb-Attribute */
    chaninfo[chan]->scroll_act->attrib = (char *)malloc(chaninfo[chan]->scroll_act->blen);
    memcpy(chaninfo[chan]->scroll_act->attrib,attr,chaninfo[chan]->scroll_act->blen);
    malen = TRUE;
    
    /* Wir sind unten am Bildschirm angelangt -> scrollen */
    if (chaninfo[chan]->scroll_act == chaninfo[chan]->scroll_lower)
    {
      if ((chaninfo[chan]->scroll_screen == chaninfo[chan]->scroll_screen_upper) ||
          (chaninfo[chan]->scroll_screen == chaninfo[chan]->scroll_upper))
      {
        chaninfo[chan]->scroll_screen = chaninfo[chan]->scroll_screen->next;
      }
      chaninfo[chan]->scroll_lower = chaninfo[chan]->scroll_lower->next;
      chaninfo[chan]->scroll_screen_upper = chaninfo[chan]->scroll_screen_upper->next;
      chaninfo[chan]->scroll_upper = chaninfo[chan]->scroll_upper->next;
    }
  }
  
  if (malen && (chan == AktChan) && paint)
  {
    /* Bildschirm neu malen */
    display_newscreen();
  }
  
  free(tmp);
  free(attr);
}



void display_ScrollDown()
{
  int i=0,ok=FALSE;
  
  /* size_rx-1 Zeile scrollen, maximal bis ganz oben */
  while ((i < size_rx-1) && (chaninfo[AktChan]->scroll_screen != chaninfo[AktChan]->scroll_upper))
  {
    chaninfo[AktChan]->scroll_screen = chaninfo[AktChan]->scroll_screen->last;
    i++;
    ok = TRUE;
  }
  
  if (ok) display_newscreen();
}


void display_ScrollUp()
{
  int i=0,ok=FALSE;

  /* size_rx-1 Zeile scrollen, maximal bis ganz nach unten */
  while ((i < size_rx-1) && (chaninfo[AktChan]->scroll_screen != chaninfo[AktChan]->scroll_screen_upper))
  {
    chaninfo[AktChan]->scroll_screen = chaninfo[AktChan]->scroll_screen->next;
    i++;
    ok = TRUE;
  }
  
  if (ok) display_newscreen();
}

