/****************************************************************************/
/**  Diverse Routinen fr alle (meist mit Pascal-Namen, hi)  dg6vj, jun 96 **/
/**                                                                        **/
/** Copyright 1996,97 Jochen Sarrazin, DG6VJ. All rights reserved.         **/
/****************************************************************************/

#ifndef TOOLBOX_H
#define TOOLBOX_H

#include <sys/socket.h>
#include <linux/ax25.h>


char *random_state;

#ifndef TRUE
  #define TRUE 1
#endif

#ifndef FALSE
  #define FALSE 0
#endif



/* Kopiert 'count' Zeichen von 'src' nach 'dest' ab Position 'start'. 
   src und dest mssen 2 VERSCHIEDENE Strings sein! */
void COPY(char *dest, char *src, int start, int count);


/* Wandelt alle Kleinbuchestaben in Grossbuchstaben um */
void Gross(char *str);


/* Wandelt alle Grossbuchestaben in Kleinbuchstaben um */
void Klein(char *str);


/* Wandelt einen Buchstaben in Grossbuchstaben um */
char upcase(char input);


/* Gibt die erste Position des Zeichens an, oder -1, wenn das Zeichen nicht in
   str ist */
int POS(char zeichen, char *str);


/* Gibt die letzte Position des Zeichens an, oder -1, wenn das Zeichen nicht in
   str ist */
int lPOS(char zeichen, char *str);


/* Schreibt das bergebene Zeichen anz mal in den dest-string */
void StringD(char *dest, int anz, char zeichen);


/* Vergleicht die beiden Strings. Rckgabe: 1, wenn gleich, 0 wenn nicht */
int strcompare(char *str1, char *str2);


/* Alle Leerzeichen links vom String lschen */
void KillSpacesLeft(char *str);


/* Alle Leerzeichen rechts lschen */
void KillSpacesRight(char *str);


/* Gre des bergebenen Files zurckgeben. Wenn nicht vorhanden wird -1 zurck gegeben. */
long filesize(char *filename);


/* ALLE Leerzeichen in str lschen, und den sich dann ergebenen String nach tmp schreiben */
void KillAllSpaces(char *tmp, char *str);


/* Wenn mehr als ein Leerzeichen nacheinander kommt, werden die brigen Leerzeichen
   gelscht. */
void OnlyOneSpace(char *tmp, char *str);


/*
 * Lscht count Zeichen aus dem String str ab Position pos
 */
void delete(char *str, int pos, int count);


/*
 * Liest Zeichen bis zum nchsten vorkommen von sign aus dem File mit der bergebenen fd ein.
 *
 * Es findet KEINE berlaufprfung statt!
 */
int fdgets(int fd, char *str, char sign);


/* Wandelt den Integer-Wert in Hex-Zahlen um */
void int2hchar(int zahl, char *c1, char *c2);


/* Initialisierung der Random-Geschichte. */
void init_random();


int file_exist(char *filename);


/********************************************************************************************/
/**  UTILITY - STUFF aus ax25d.c   Copyright (C) 1995 by Darryl L. Miles, G7LED.    *********/

/* Up to user to make sure 'h' is at least 'char h[AX25_CALLSID]' **/
char *ax25_ntoa(char *peer, const ax25_address *axa);


/* Should arg1 (char *h) really be 'const char *h' ?? **/
int ax25_aton(ax25_address *axa, const char *h);


/* Should arg1 (char *h) really be 'const char *h' ?? **/
int ax25_atonpath(struct full_sockaddr_ax25 *ax, const char *h);

/************ END ax25d.c - STUFF ***********************************************************/
/********************************************************************************************/


/* Kopiert einen Integer-Array in einen anderen */
void intcpy(int *dest, int *src, int count);


char *dec2bin(unsigned int dec);


long get_freemem();


/*
 * Sucht in den ersten count Bytes in str nach search. In search darf kein 0-Byte
 * vorkommen. Zurckgegeben wird die Position von search in str.
 *
 * Ist es garnicht enthalten, wird -1 zurck gegeben.
 */
int memstr(char *str, char *search, int count);



#endif
